#!/usr/bin/perl -w
#
# Schools.pm provides a hash table of info on schools to which you
# will apply.
# Modified from Matthew J. Miller by Pingle Wang 

package Schools;
use strict;

# Create the hash keys that we will use.
our $PUB_KEY = "pub";
our $UNIV_KEY = "univ";
our $DEPT_KEY = "dept";
our $TO_NAME_KEY = "to_name";
our $ADDR_KEY = "addr";
our $URL_KEY = "url";
our $LTR_LINK_KEY = "ltr_url";
our $DEADLINE_KEY = "deadline";
our $TRANSCRIPT = "transcript";
our $RESEARCH = "research";
our $DO_GENERATE_KEY = "do_generate";

# univ is the global hash table that we will use.
our %univ_;

# Here is an example of how to create and entry in the has table.
#------------------------------------------------------------------------------------------
my $ALBERTA_KEY = "alberta";
$univ_{$ALBERTA_KEY}{$UNIV_KEY} = "University of Alberta";
$univ_{$ALBERTA_KEY}{$DEPT_KEY} = "Alberta School of Business";
$univ_{$ALBERTA_KEY}{$TO_NAME_KEY} = undef;
$univ_{$ALBERTA_KEY}{$ADDR_KEY} = 
	"Alberta School of Business\\\\\n".
	"University of Alberta\\\\\n".
	"11211 Saskatchewan Dr NW\\\\\n".
	"Edmonton, AB T6G 2R6, Canada";
$univ_{$ALBERTA_KEY}{$TRANSCRIPT} = undef;
$univ_{$ALBERTA_KEY}{$RESEARCH} = undef;
$univ_{$ALBERTA_KEY}{$URL_KEY} = "https://www.careers.ualberta.ca/Competition/A103040378/";
$univ_{$ALBERTA_KEY}{$LTR_LINK_KEY} = "fsachair\@ualberta.ca";
$univ_{$ALBERTA_KEY}{$DO_GENERATE_KEY} = 0;
#------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------
my $BARUCH_KEY = "baruch";
$univ_{$BARUCH_KEY}{$UNIV_KEY} = "Baruch College";
$univ_{$BARUCH_KEY}{$DEPT_KEY} = "Bert W. Wasserman Department of Economics and Finance";
$univ_{$BARUCH_KEY}{$TO_NAME_KEY} = undef;
$univ_{$BARUCH_KEY}{$ADDR_KEY} = 
	"Bert W. Wasserman Department of Economics and Finance\\\\\n".
	"Baruch College\\\\\n".
	"One Bernard Baruch Way\\\\\n".
	"New York, New York 10010";
$univ_{$BARUCH_KEY}{$TRANSCRIPT} = undef;
$univ_{$BARUCH_KEY}{$RESEARCH} = undef;
$univ_{$BARUCH_KEY}{$URL_KEY} = "https://home.cunyfirst.cuny.edu/psp/cnyepprd/GUEST/HRMS/c/HRS_HRAM.HRS_CE.GBL";
$univ_{$BARUCH_KEY}{$LTR_LINK_KEY} = "https://www.baruch.cuny.edu/hrref/";
$univ_{$BARUCH_KEY}{$DO_GENERATE_KEY} = 0;
#------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------
my $CITYU_KEY = "cityu";
$univ_{$CITYU_KEY}{$UNIV_KEY} = "City University of Hong Kong";
$univ_{$CITYU_KEY}{$DEPT_KEY} = "Department of Economics and Finance";
$univ_{$CITYU_KEY}{$TO_NAME_KEY} = undef;
$univ_{$CITYU_KEY}{$ADDR_KEY} = 
	"Department of Economics and Finance\\\\\n".
	"City University of Hong Kong\\\\\n".
	"Tat Chee Avenue, Kowloon Tong, Hong Kong";
$univ_{$CITYU_KEY}{$TRANSCRIPT} = undef;
$univ_{$CITYU_KEY}{$RESEARCH} = undef;
$univ_{$CITYU_KEY}{$URL_KEY} = "http://jobs.cityu.edu.hk";
$univ_{$CITYU_KEY}{$LTR_LINK_KEY} = "efpost\@cityu.edu.hk";
$univ_{$CITYU_KEY}{$DO_GENERATE_KEY} = 0;
#------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------
my $CKGSB_KEY = "ckgsb";
$univ_{$CKGSB_KEY}{$UNIV_KEY} = "Cheung Kong Graduate School of Business";
$univ_{$CKGSB_KEY}{$DEPT_KEY} = "Department of Finance";
$univ_{$CKGSB_KEY}{$TO_NAME_KEY} = undef;
$univ_{$CKGSB_KEY}{$ADDR_KEY} = 
	"Department of Finance\\\\\n".
	"Cheung Kong Graduate School of Business\\\\\n".
	"Beijing, China";
$univ_{$CKGSB_KEY}{$TRANSCRIPT} = undef;
$univ_{$CKGSB_KEY}{$RESEARCH} = undef;
$univ_{$CKGSB_KEY}{$URL_KEY} = "http://recruit.ckgsb.com:8080/apply";
$univ_{$CKGSB_KEY}{$LTR_LINK_KEY} = "http://recruit.ckgsb.com:8080/apply";
$univ_{$CKGSB_KEY}{$DO_GENERATE_KEY} = 0;
#------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------
my $IMPERIAL_KEY = "imperial";
$univ_{$IMPERIAL_KEY}{$UNIV_KEY} = "Imperial College Business School";
$univ_{$IMPERIAL_KEY}{$DEPT_KEY} = "Finance Department";
$univ_{$IMPERIAL_KEY}{$TO_NAME_KEY} = undef;
$univ_{$IMPERIAL_KEY}{$ADDR_KEY} = 
	"Finance Department\\\\\n".
	"Imperial College Business School\\\\\n".
	"Ayrton Rd\\\\\n".
	"London SW7 2AZ, United Kingdom";
$univ_{$IMPERIAL_KEY}{$TRANSCRIPT} = undef;
$univ_{$IMPERIAL_KEY}{$RESEARCH} = undef;
$univ_{$IMPERIAL_KEY}{$URL_KEY} = "www.imperial.ac.uk/jobs";
$univ_{$IMPERIAL_KEY}{$LTR_LINK_KEY} = "www.imperial.ac.uk/jobs";
$univ_{$IMPERIAL_KEY}{$DO_GENERATE_KEY} = 0;
#------------------------------------------------------------------------------------------
# Perl needs a return value for this file.
1;
