#!/usr/bin/env python
# coding: utf-8
# Created by Pingle Wang (wangpingle.com)
# This script creates packages for school application

import pandas as pd
import os
import re
import shutil
from PyPDF2 import PdfFileMerger
import time
def merger(output_path, input_paths):
    pdf_merger = PdfFileMerger()
    file_handles = []
 
    for path in input_paths:
        pdf_merger.append(path)
 
    with open(output_path, 'wb') as fileobj:
        pdf_merger.write(fileobj)

        
# specify research statement dir 
rs = "your_research_statement_dir/research_statements.pdf"
# specify teaching statement dir
ts = "your_teaching_statement_dir/teaching_statements.pdf"
# specify transcript dir
trans = "your_transcript_dir/Transcript.pdf"
# specify resume dir
cv = "your_cv_dir/cv.pdf"
# specify list of reference dir
lor = "your_lor_dir/lor.pdf"

# paper 0 is your job market paper
paper0 = "your_job_market_paper_dir/jmp.pdf"
# paper1 2 3 are optional
paper1 = "paper1.pdf"
paper2 = "paper2.pdf"
paper3 = "paper3.pdf"
paper = [paper0,paper1,paper2,paper3]     

df = pd.read_excel("School_to_Apply.xlsx")
df["Letterlink"] = df["Letterlink"].fillna("")
df["Contact"] = df["Contact"].fillna("")
df["Receive"] = df["Receive"].fillna(0)
df["Paper"] = len(paper)
df["Transcript"] = df["Transcript"].fillna(0)
df["Onefile"] = df["Onefile"].fillna(0)


for index, row in df.loc[df["Receive"]==0].iterrows():
    sd = "./packages/{}".format(row["Shortcut"])
    cl = "./cover_letters/coverletter_{}.pdf".format(row["Shortcut"])
    if not os.path.exists(sd):
        os.makedirs(sd)
    else:
        shutil.rmtree(sd)
        time.sleep(0.3)
        os.makedirs(sd)
    if row["Onefile"] == 0:
        if row["RS"] == 1:
            shutil.copy2(rs,'{}/First_Last_Affiliation_research_statement.pdf'.format(sd))
        if row["Transcript"] == 1:
            shutil.copy2(trans,'{}/First_Last_Affiliation_transcript.pdf'.format(sd))
        for p in range(int(row["Paper"])):
            if p == 0:
                shutil.copy2(paper[p],'{}/First_Last_Affiliation_JMP.pdf'.format(sd))
            else:
                shutil.copy2(paper[p],'{}/First_Last_Affiliation_paper{}.pdf'.format(sd,str(p+1)))
        # some schools ask to merge all other working papers into one file
        files_agg = paper[1:int(row["Paper"])]
        merger('{}/First_Last_Affiliation_WorkingPapers.pdf'.format(sd), files_agg)
        shutil.copy2(cv,'{}/First_Last_Affiliation_curriculum_vitae.pdf'.format(sd))
        shutil.copy2(ts,'{}/First_Last_Affiliation_teaching_statement.pdf'.format(sd))
        shutil.copy2(cl,'{}/First_Last_Affiliation_cover_letter.pdf'.format(sd))
        shutil.copy2(lor,'{}/First_Last_Affiliation_list_of_references.pdf'.format(sd))
    else:
        files_agg = [cl,cv,ts,lor]  
        if row["RS"] == 1:
            files_agg.append(rs)
        if row["Transcript"] == 1:
            files_agg.append(trans)
        files_agg = files_agg + paper[0:int(row["Paper"])]
        merger('{}/First_Last_Affiliation_packages.pdf'.format(sd), files_agg)

