#!/usr/bin/env python
# coding: utf-8
# created by Pingle Wang (wangpingle.com)
import pandas as pd
import os
import re

def url_id(url):
    a = url.split("/")
    if re.match("\d+",a[-1]):
        a[-1] = " (%s)" % a[-1]
    a = "/".join(a)
    return a

def school_block(row):
    sc = row["Shortcut"]
    SC = '${}_KEY'.format(sc.upper())
    s = '#------------------------------------------------------------------------------------------\n'
    s += 'my %s = "%s";\n' % (SC, sc)
    s += '$univ_{%s}{$UNIV_KEY} = "%s";\n' % (SC, row["University"].strip().replace("&","\\\\&"))
    s += '$univ_{%s}{$DEPT_KEY} = "%s";\n' % (SC, row["Department"].strip())
    if row["Contact"] == "":
        s += '$univ_{%s}{$TO_NAME_KEY} = undef;\n' % (SC)
    else:
        s += '$univ_{%s}{$TO_NAME_KEY} = "%s";\n' % (SC, row["Contact"].strip())
    s += '$univ_{%s}{$ADDR_KEY} = \n' % (SC)
    s += '\t"' + row["Department"].strip() + "\\"*5+'n".\n'
    s += '\t"' + row["University"].strip().replace("&","\\\\&") + "\\"*5+'n".\n'
    add = row["Address"].split(",")
    if add[-1] == " Canada":
        add = ['\t"'+i.strip()+"\\"*5+'n".\n' for i in add[0:-3]]+ ['\t"'+",".join(add[-3:]).strip()+'";\n']
    elif add[-1] == " Hong Kong" or add[-1] == " China":
    	add = ['\t"'+",".join(add).strip()+'";\n']
    elif "Singapore" in add[-1]:
    	add = ['\t"'+i.strip()+"\\"*5+'n".\n' for i in add[0:1]]+ ['\t"'+",".join(add[1:]).strip()+'";\n']
    elif "Kingdom" in add[-1]:
    	add = ['\t"'+i.strip()+"\\"*5+'n".\n' for i in add[0:1]]+ ['\t"'+",".join(add[1:]).strip()+'";\n']
    else:
        add = ['\t"'+i.strip()+"\\"*5+'n".\n' for i in add[0:-2]]+ ['\t"'+",".join(add[-2:]).strip()+'";\n']
    for ad in add:
        s += ad
    if row["Transcript"] == 0:
        s += '$univ_{%s}{$TRANSCRIPT} = undef;\n' % (SC)
    else:
        s += '$univ_{%s}{$TRANSCRIPT} = 1;\n' % (SC)
    if row["RS"] == 0:
        s += '$univ_{%s}{$RESEARCH} = undef;\n' % (SC)
    else:
        s += '$univ_{%s}{$RESEARCH} = 1;\n' % (SC)
    s += '$univ_{%s}{$URL_KEY} = "%s";\n' % (SC, row["Url"].replace("@","\\@"))
    if row["Letterlink"] == "":
        s += '$univ_{%s}{$LTR_LINK_KEY} = "%s";\n' % (SC, row["Url"].replace("@","\\@"))
    else:
        s += '$univ_{%s}{$LTR_LINK_KEY} = "%s";\n' % (SC, row["Letterlink"].replace("@","\\@"))
    s += '$univ_{%s}{$DO_GENERATE_KEY} = %s;\n#------------------------------------------------------------------------------------------\n' % (SC,row["Receive"])
    return s
    
    
df = pd.read_excel("School_to_Apply.xlsx")
df = df.loc[~df["Shortcut"].isnull()]
df["Letterlink"] = df["Letterlink"].fillna("")
df["Contact"] = df["Contact"].fillna("")
df["Receive"] = df["Receive"].fillna(0)
df["Receive"] = df["Receive"].astype(int).astype(str)
df["RS"] = df["RS"].fillna(0)
df["Transcript"] = df["Transcript"].fillna(0)
df["Department"] = df["Department"].fillna("Department of Finance")

with open("pre_Schools.pm",'r') as pre:
    pre_schools = pre.read()
with open("Schools.pm","w") as f:
    f.write(pre_schools)
    f.write("\n")
    for index, row in df.iterrows():
        f.write(school_block(row))
    f.write("# Perl needs a return value for this file.\n1;\n")


